var InFormEnter = {

// my variables ------------------------------------------------------------
m_MarkerNumber : 0,
m_LastInput : null,
m_LastPopupMenu : null,
m_IsActiveMarker : false,
m_ActiveMarkers : [],
m_LastFocusURL : "",

/*
// dummy debug dump ------------------------------------------------------------------
//###
ddd: function (msg) 
{
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                       .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("_" + msg + "_");
},
*/

//------------------------------------------------------------------------------
OnMenuItemSelect: function(index, event)
{
 var menuTextItems = unescape(InFormEnterCommon.g_MenuSet).split("\n"); 
 if (index>=0 && index<menuTextItems.length)
 {
  var et_input = InFormEnter.m_LastInput;
  if (et_input)
  {
   var menu_value = "";
   var line = menuTextItems[index];
   if (line.length > 0)
   {
    line=InFormEnterCommon.HideSharp(line);
    var tmp = line.split ("#");
    if (tmp.length > 1)
    {
     var arraySize = tmp.length;
     if (arraySize == 2) // no macros
      menu_value = InFormEnterCommon.HideAt(InFormEnterCommon.UnhideSharp(tmp[0]));
     else
      menu_value = InFormEnterCommon.Macro(tmp[arraySize-2], true);
    }
    else 
     menu_value = InFormEnterCommon.HideAt(InFormEnterCommon.UnhideSharp(line));
   }
   
   var pos2Sel;
   if (event.ctrlKey)
   {
    var s1 = et_input.value.substr(0, et_input.selectionStart);
    var s2 = et_input.value.substr(et_input.selectionEnd);
    et_input.value = s1 + menu_value + s2;
    pos2Sel = s1.length + menu_value.length;
   }
   else
   {
    et_input.value = menu_value;
    pos2Sel = menu_value.length;
   }

   et_input.focus();
   et_input.setSelectionRange(pos2Sel,pos2Sel);
  }
  
 }
},

//------------------------------------------------------------------------------
Add2Profile: function()
{
  var et_input = InFormEnter.m_LastInput;

  if (et_input && et_input.value.length > 0)
  {
   var newEntry;
   if (et_input.selectionStart == et_input.selectionEnd)
    newEntry = et_input.value;
   else
    newEntry = et_input.value.substr(et_input.selectionStart, et_input.selectionEnd);

   var profileId = InFormEnterCommon.GetPrefInt("ProfileCurrent", 1);
   InFormEnterCommon.g_MenuSet = unescape(InFormEnterCommon.GetPrefChar(profileId+".MenuSet", ""));
   InFormEnterCommon.g_MenuSet = newEntry.replace(/\n/g, "@@") + "\n" + InFormEnterCommon.g_MenuSet;
   InFormEnterCommon.SetPrefChar(profileId+".MenuSet", escape(InFormEnterCommon.g_MenuSet));
  }
},

//------------------------------------------------------------------------------
CheckMarkerClick: function(event)
{
 var markerID = event.target.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // over ife marker
 {
  if(event.button == 0 ||  // left mouse click
     (event.button == 2 && InFormEnterCommon.g_MarkerRightClick == 1)) // right mouse click && show main menu
  {
   var et_marker = event.target;
   var et_input = et_marker.previousSibling;
   InFormEnter.m_LastInput = et_input;
   var maxlength = et_input.getAttribute("maxlength");

   et_input.focus();
   InFormEnterCommon.PopupFill('ife_popup_mi_hint', et_input.name, maxlength); 

   var pm1 = document.getElementById("ife_popup");
   InFormEnter.m_LastPopupMenu = pm1;
   pm1.showPopup(document.documentElement,
                 event.screenX + 7,                     // 14 is markers width
                 event.screenY - InFormEnterCommon.g_MenuItemsCount*10 - 20, // 20 is average menu item height
                 "popup","bottomleft","topleft");
  }

  if(event.button == 2 && InFormEnterCommon.g_MarkerRightClick == 0) // right mouse click && show profiles list
  {
   InFormEnterCommon.CheckDefaultProfile();

   var pm2 = document.getElementById("informenter-popup");
   InFormEnter.m_LastPopupMenu = pm2;
   pm2.showPopup(document.documentElement,
                 event.screenX,
                 event.screenY - 20,
                 "popup","bottomleft","topleft");
   //document.getElementById("contentAreaContextMenu").hidden = true;
  }

  return false;
 }
},

//------------------------------------------------------------------------------
CheckMarkerDoubleClick: function(event)
{
 var markerID = event.target.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // over ife marker
 {
   var et_marker = event.target;
   if(et_marker.getAttribute("src").indexOf("informenter/skin/marker_inhistory_one.png") != -1)
   {
    var et_input = et_marker.previousSibling;
    et_input.value = InFormEnterCommon.GetCurrentProfileFirstItemFromFormCache (et_input.getAttribute("name"));
    InFormEnter.m_LastPopupMenu.hidePopup(); 
    return false;
  }
 }
},

//------------------------------------------------------------------------------
CheckAccelKey: function(event)
{
 var focused_input = document.commandDispatcher.focusedElement;
 if(!focused_input || !focused_input.nextSibling || !focused_input.nextSibling.id)
  return; // not input with markers

 var markerID = focused_input.nextSibling.id.toString();
 var pos = markerID.indexOf ("_ife_marker_");
 if(pos != -1) // in fine input
 {
   var et_input = focused_input;
   InFormEnter.m_LastInput = et_input;
   var maxlength = et_input.getAttribute("maxlength");

   InFormEnterCommon.PopupFill('ife_popup_mi_hint', et_input.name, maxlength); 

   var x,y;
   var tb = document.getElementById("navigator-toolbox");
   if (tb)
   {
    x = tb.boxObject.screenX; 
    y = tb.boxObject.screenY+tb.boxObject.height;
   }
   else
   {
    x = window.screenX;
    y = window.screenY+120;
   }

   var point = InFormEnterCommon.GetElementXY (et_input);
   x += (point.x - window._content.scrollX + 20); 
   y += (point.y - window._content.scrollY + et_input.clientHeight/2 - InFormEnterCommon.g_MenuItemsCount*10 - 20); // 20 is average menu item height;

   var pm = document.getElementById("ife_popup");
   pm.showPopup(document.documentElement,
                x,
                y,
                "popup","bottomleft","topleft");
 }

 return true;
},

//------------------------------------------------------------------------------
OnContextPopupShowing: function()
{
 var isHidden = true;
 if (InFormEnterCommon.g_IsOn && gContextMenu != null && gContextMenu.onTextInput)
 {
  isHidden = false;
  InFormEnter.m_LastInput = gContextMenu.target;
 }
 document.getElementById("ife_context").hidden = isHidden;
},

//------------------------------------------------------------------------------
OnContextSubPopupShowing: function()
{
 if (InFormEnterCommon.g_IsOn)
 {
  if (gContextMenu != null && gContextMenu.onTextInput && InFormEnter.m_LastInput != null)
  {
   var et_input = InFormEnter.m_LastInput;
   if (et_input != null)
   {
    var maxlength = et_input.getAttribute("maxlength");
    InFormEnterCommon.PopupFill('ife_context_popup_mi_hint', et_input.name, maxlength); 
   }
  }
 }
},

//------------------------------------------------------------------------------
OnOptions: function()
{
 window.openDialog("chrome://informenter/content/ife_options.xul","ife_options","chrome,centerscreen,modal,resizable");
 InFormEnterCommon.ReadState();
 InFormEnter.RemoveMarkers(window._content); // to change markers style
 InFormEnter.ProcessPage(null, "load");
},

//------------------------------------------------------------------------------
OnProfileCurrent: function(profileId)
{
 InFormEnterCommon.SetPrefInt("ProfileCurrent", profileId);
 if(InFormEnterCommon.g_IsOn)
 {
  // to reload markers 
  InFormEnter.RemoveMarkers(window._content); 
  InFormEnter.ProcessPage(null, "load");
 }
},

//------------------------------------------------------------------------------
OnProfilesMenu: function(menu_item_id)
{
 InFormEnterCommon.CheckDefaultProfile();

 var profilesArr = InFormEnterCommon.GetPrefChar("Profiles", "").split("\n");
 var profileCurrentId = InFormEnterCommon.GetPrefInt("ProfileCurrent", 1);
 var mi_profile = document.getElementById(menu_item_id);

 // remove previous menu
 while (mi_profile.nextSibling != null)
  mi_profile.parentNode.removeChild (mi_profile.nextSibling);

 // template
 var mi_template = mi_profile.cloneNode(true);
 mi_template.setAttribute("hidden", false);

 // create new items
 var menuItemsCount = 0;
 for (var i=0; i<profilesArr.length; i++)
 {
  var profileData = profilesArr[i].split("\t");
  var mi_new = mi_template.cloneNode(true);
  mi_new.setAttribute("label", unescape(profileData[0]));
  mi_new.setAttribute("oncommand", "InFormEnter.OnProfileCurrent(" + profileData[1] + ");");
  if (profileCurrentId == profileData[1])
   mi_new.setAttribute("checked", true);
  mi_profile.parentNode.appendChild (mi_new);
 }
},

//------------------------------------------------------------------------------
ShowCurrentState: function() 
{
 // Read state
 InFormEnterCommon.ReadState();

 // On\Off
 var sbpi = document.getElementById('informenter-status');
 sbpi.setAttribute("status", InFormEnterCommon.g_IsOn ? "on" : "off");
 sbpi.setAttribute("tooltip", InFormEnterCommon.g_IsOn ? "informenter-tooltip-on" : "informenter-tooltip-off" );

 // Options Placement
 document.getElementById('informenter-status').setAttribute("hidden", InFormEnterCommon.g_OptionsPlacement==0 ? "false" : "true");
 document.getElementById('informenter-menu').setAttribute("hidden", InFormEnterCommon.g_OptionsPlacement==1 ? "false" : "true");

 // Context menu
 var menu = document.getElementById("contentAreaContextMenu");
 menu.addEventListener("popupshowing", InFormEnter.OnContextPopupShowing, false);
},

//------------------------------------------------------------------------------
OnStatusClick: function(event) 
{
 if (event.button == 2) // right mouse click
 {
  InFormEnterCommon.g_IsOn = !InFormEnterCommon.g_IsOn;
  InFormEnterCommon.SetPrefInt("On", InFormEnterCommon.g_IsOn);
  InFormEnter.ProcessPage(null, "load");
  return;
 }
},

//------------------------------------------------------------------------------
// Floating markers

CheckActiveMarker: function()
{
 if (InFormEnter.m_ActiveMarkers.length && InFormEnter.m_IsActiveMarker == false)
 {
  for (var i=InFormEnter.m_ActiveMarkers.length-1; i>=0; i--)
   InFormEnter.m_ActiveMarkers[i].style.display = "none";
  InFormEnter.m_ActiveMarkers = [];
  InFormEnter.m_IsActiveMarker = false;
 }
},

//-------------------------------------------------
ife_OnInputOver: function (event)
{
 if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
 {
  event.target.nextSibling.style.display = "inline";
  InFormEnter.m_IsActiveMarker = true;
  InFormEnter.m_ActiveMarkers.push(event.target.nextSibling);
 }
},

ife_OnInputOut: function ()
{
 if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
 {
  InFormEnter.m_IsActiveMarker = false;
  window.setTimeout(function () { InFormEnter.CheckActiveMarker() }, 200);
 }
},

ife_OnMarkerOver: function ()
{
 if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
 {
  InFormEnter.m_IsActiveMarker = true;
 }
},

ife_OnMarkerOut: function ()
{
 if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
 {
  InFormEnter.m_IsActiveMarker = false;
  window.setTimeout(function () { InFormEnter.CheckActiveMarker() }, 200);
 }
},

//-------------------------------------------------
MoveMarker: function(field, img)
{
 img.style.width  = "1px";
 img.style.height = "1px";
 img.style.top  = "0px";
 img.style.left  = "0px";
 var displayOld = img.style.display;
 img.style.display = "inline";

 var inputPos = InFormEnterCommon.GetElementLeftTopFromBody(field);
 var markerPos = InFormEnterCommon.GetElementLeftTopFromBody(img);
 //InFormEnter.ddd("MoveMarker old pos:"+img.id+", left:"+markerPos.left+", top:"+markerPos.top); //###

 var xReal = markerPos.left;
 var yReal = markerPos.top; 
 var xNeed = inputPos.left + field.offsetWidth + 1;
 var yNeed = inputPos.top + (field.offsetHeight - img.offsetHeight);

 var xy_delta = 3;
 if(Math.abs(xReal - xNeed) > xy_delta || Math.abs(yReal - yNeed) > xy_delta)
 {
  img.style.left = (xNeed - xReal) + "px";
  img.style.top  = (yNeed - yReal) + "px";
  //InFormEnter.ddd("MoveMarker new style:"+img.id+", left:"+img.style.left+", top^"+img.style.top); //###
 }

 var w = 14;
 var h = Math.min(field.offsetHeight, 19);
 img.style.width  = w + "px";
 img.style.height = h + "px";

 img.style.display = displayOld;
},

//------------------------------------------------------------------------------
AttachMarker: function(doc,field,checkFormCache) 
{
 var markerNeed = false;

 if (field.nextSibling != null)
 {
  try   
  {
   var className = field.nextSibling.getAttribute("class");
   if (className.indexOf ("ife_marker") == -1)
    markerNeed = true;
  }
  catch (e)
  {
   markerNeed = true;
  }
 }
 else
  markerNeed = true;

 if (markerNeed)
 {
  // field
  //field.setAttribute("title", "marginRight="+field.style.marginRight);
  field.style.marginRight = "0px";
  field.style.paddingRight = "0px";
 
  // img
  var imgNode = doc.createElement("img");
  imgNode.setAttribute("id", field.getAttribute("name") + "_ife_marker_" + InFormEnter.m_MarkerNumber);
  if(checkFormCache && InFormEnterCommon.g_FormHistory && InFormEnterCommon.g_IsOn && InFormEnterCommon.g_ColorizeItems)
  {
    var itemsCount = InFormEnterCommon.GetCurrentProfileItemsCountInFormCache(field.name);
    if(itemsCount > 1)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker_inhistory.png");
    if(itemsCount == 1)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker_inhistory_one.png");
    if(itemsCount == 0)
     imgNode.setAttribute("src", "chrome://informenter/skin/marker.png");
  }
  else
   imgNode.setAttribute("src", "chrome://informenter/skin/marker.png");

  imgNode.setAttribute("class", "ife_marker"); 
  var styleAttribute = "position:relative; left:0px; top:0px; z-index: 999; cursor:pointer; vertical-align: bottom; border: 0; width: 1px; height: 1px;";
  
  if (InFormEnterCommon.g_MarkersMode < 0 || InFormEnterCommon.g_MarkersMode == 3) // disable markers OR autofloat markers
   styleAttribute += " display:none;";
  if (InFormEnterCommon.g_MarkersMode == 1 || InFormEnterCommon.g_MarkersMode == 2)  
   styleAttribute += " display:inline;";
  imgNode.setAttribute("style", styleAttribute);

  var maxlength = field.getAttribute("maxlength");
  imgNode.setAttribute("title", InFormEnterCommon.StrMaxInputLength (maxlength));

  // MM==2
  if(InFormEnterCommon.g_MarkersMode == 2) // reduce inputs width
  {
   var newWidth = field.offsetWidth;
   if (newWidth >= 36)
   {
    newWidth -= 18; 
	field.style.width = newWidth+"px"; 
   }
  }
 
  // Variant Old \/
  field.parentNode.insertBefore (imgNode, field.nextSibling);
  //InFormEnter.ddd ("attach marker with id:"+imgNode.id+", field width:"+field.offsetWidth) //###
  InFormEnter.MoveMarker(field, imgNode);
  // Variant Old /\

  imgNode.addEventListener("click", function (event) { InFormEnter.CheckMarkerClick(event) }, false); // since 0.71 version
  imgNode.addEventListener("contextmenu", function (event) { InFormEnter.CheckMarkerClick(event) }, false); // since 0.71 version
  imgNode.oncontextmenu = function(event){ return false; };
  imgNode.addEventListener("dblclick", function (event) { InFormEnter.CheckMarkerDoubleClick(event) }, false); // since 0.71 version
  
  /*
  // MM==2
  if(InFormEnterCommon.g_MarkersMode == 2) // reduce inputs width
  {
   var newWidth = field.offsetWidth;
   if (newWidth >= 36)
   {
    newWidth -= 18; 
	field.style.width = newWidth+"px"; 
   }
  }
  */

  // MM==3
  if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
  {
   field.addEventListener("mouseover", function (event) { InFormEnter.ife_OnInputOver(event) }, false); // since 0.71 version 
   field.addEventListener("mouseout",  function ()      { InFormEnter.ife_OnInputOut (); },     false); // since 0.71 version 
   imgNode.addEventListener("mouseover", function () { InFormEnter.ife_OnMarkerOver (); }, false); // since 0.71 version 
   imgNode.addEventListener("mouseout",  function () { InFormEnter.ife_OnMarkerOut ();  }, false); // since 0.71 version 
  }

  // 
  InFormEnter.m_MarkerNumber++;
 }
},

//------------------------------------------------------------------------------
AddMarkers: function(windowCurrent) 
{
 //InFormEnter.ddd("AddMarkers:"+windowCurrent); //###

 // Process self frame //
 var doc = windowCurrent.document;
 var inputs = doc.getElementsByTagName("input");

 // markers to inputs
 for (var i=0; i<inputs.length; i++)
 {
  var input = inputs[i];
  var type = input.getAttribute("type");
  if(type != null)
   type = type.toLowerCase();
  if (type == null || type == "" || type == "text" || type == "password" || type == "search")
  {
   if(InFormEnterCommon.IsInputVisibleAndEditable(input))
    InFormEnter.AttachMarker(doc,input,true);
  }
 }

 // markers to textareas
 inputs = doc.getElementsByTagName("textarea");
 for (i=0; i<inputs.length; i++)
 {
  if(InFormEnterCommon.IsInputVisibleAndEditable(inputs[i]))
   InFormEnter.AttachMarker(doc,inputs[i],false);
 }

 // Process subframes //
 for (i=0; i<windowCurrent.frames.length; i++)
  InFormEnter.AddMarkers(windowCurrent.frames[i]);
},

//------------------------------------------------------------------------------
RemoveMarkers: function(windowCurrent) 
{
 // Process self frame //
 var doc = windowCurrent.document;

 var images = doc.getElementsByClassName("ife_marker");
 for (var i=images.length-1; i>=0; i--)
 {
  var image = images[i];
  image.parentNode.removeChild (image);
 }

 // Process subframes //
 for (i=0; i<windowCurrent.frames.length; i++)
  InFormEnter.RemoveMarkers(windowCurrent.frames[i]);
},

//------------------------------------------------------------------------------
ClearDoubleMarkers: function(windowCurrent) 
{
 // Process self frame //
 var doc = windowCurrent.document;
 
 var images = doc.getElementsByClassName("ife_marker");
 for (var i=images.length-1; i>=0; i--)
 {
  var image = images[i];
  var et_prev = image.previousSibling;
  if(et_prev == null || 
    (et_prev.nodeName != "INPUT" && et_prev.nodeName != "TEXTAREA") ||
     et_prev.offsetWidth < 2 )
   {
    //InFormEnter.ddd("ClearDoubleMarkers:"+image.id); //### 
    image.parentNode.removeChild(image);
   }
 }

 // Process subframes //
 for (i=0; i<windowCurrent.frames.length; i++)
  InFormEnter.ClearDoubleMarkers(windowCurrent.frames[i]);
},

//------------------------------------------------------------------------------
MoveAllMarkers: function(windowCurrent) 
{
 //InFormEnter.ddd("MoveAllMarkers"); //###
 // Process self frame //
 var doc = windowCurrent.document;

 var images = doc.getElementsByClassName("ife_marker");
 for (var i=images.length-1; i>=0; i--)
 {
  var image = images[i];
  var et_prev = image.previousSibling;
  if(et_prev && (et_prev.nodeName == "INPUT" || et_prev.nodeName == "TEXTAREA"))
   InFormEnter.MoveMarker(et_prev, image)
 }

 // Process subframes //
 for (i=0; i<windowCurrent.frames.length; i++)
  InFormEnter.MoveAllMarkers(windowCurrent.frames[i]);
},

//------------------------------------------------------------------------------
ProcessPage: function(event_type) 
{
 var ife_current_href = window._content.document.location.href.toString();
 //InFormEnter.ddd("ProcessPage:"+event_type+", "+ife_current_href); //###

 // page process 
 InFormEnter.m_MarkerNumber = 0;
 if (InFormEnterCommon.g_IsOn)
 {
  InFormEnter.AddMarkers(window._content);

  if(InFormEnterCommon.g_MarkersMode == 3) // autofloat markers
  {
   if(InFormEnter.m_MarkerNumber > 0) // markers rebuilded
   {
    InFormEnter.m_IsActiveMarker = false;
    InFormEnter.m_ActiveMarkers = [];
   }
  }

  InFormEnter.ClearDoubleMarkers(window._content);
 }
 else
  InFormEnter.RemoveMarkers(window._content); 

 InFormEnter.ShowCurrentState();

 // Hack start. It is dirty method to cheat google and facebook search design
 if(event_type == "load")
  window.setTimeout(function () { InFormEnter.ProcessPage("timer"); }, 300);
 // Hack end

 //InFormEnter.ddd("ProcessPage:"+event_type+" end"); //###
}

};

//------------------------------------------------------------------------------
window.addEventListener("DOMContentLoaded",function(event) {InFormEnter.ProcessPage("load");}, false);
window.addEventListener("load", function(event) {InFormEnter.ProcessPage("load"); }, false);
window.addEventListener("focus",function(event) {InFormEnter.ProcessPage("focus");}, false);
window.addEventListener("resize",function() {InFormEnter.MoveAllMarkers(window._content);}, false);

