var InFormEnterOptions = {

//------------------------------------------------------------------------------
m_profiles : new Array(),
m_currentId : 0,
m_OptionsLoaded : 0,

//------------------------------------------------------------------------------
indexOfProfileId: function(profileId) 
{
 var index = 0;
 for (var i=0; i<this.m_profiles.length; i++)
 {
  if (this.m_profiles[i][1] == profileId)
  {
   index = i;
   break;
  }
 }
 return index;
},

//------------------------------------------------------------------------------
profilesListFill: function(et_list) 
{
 while (et_list.hasChildNodes())
  et_list.removeChild (et_list.firstChild);

 for (var i=0; i<this.m_profiles.length; i++)
 {
  if (this.m_profiles[i][1] > 0)
  {
   var newItem = et_list.appendItem(this.m_profiles[i][0]);
   newItem.setAttribute("id", this.m_profiles[i][1]);
  }
 }
},

//------------------------------------------------------------------------------
profileListSelect: function(et_list, profileId) 
{
 var menu_items=et_list.firstChild.childNodes;
 for (var i=0;i<menu_items.length;i++) 
 {
  if (menu_items[i].getAttribute("id")==profileId) 
  {
   et_list.selectedIndex=i;
   break;
  }
 }
},

//------------------------------------------------------------------------------
profileListUpdateAndSelect: function(profileId) 
{
 var et_list = document.getElementById("ife_profile_menu");
 this.profilesListFill(et_list); 
 this.profileListSelect(et_list, profileId);

 this.buttonDelValidate(et_list);
 this.OnProfileSelect();

 var et_text = document.getElementById("ife_options_text");
 et_text.focus();
},

//------------------------------------------------------------------------------
buttonDelValidate: function(et_list) 
{
 var menu_items = et_list.firstChild.childNodes;
 var et_del = document.getElementById("ife_profile_del");
 et_del.setAttribute ("disabled", menu_items.length <= 1);
},

//------------------------------------------------------------------------------
profileNextNumCreate: function() 
{
 var result = InFormEnterCommon.GetPrefInt("ProfileNext", 1);
 var nextNum = result;
 if (nextNum < 32000)
  nextNum++;
 else
  nextNum = 0;
 InFormEnterCommon.SetPrefInt("ProfileNext", nextNum);
 return result;
},

//------------------------------------------------------------------------------
OnOptionsLoad: function()  
{
 InFormEnterCommon.CheckDefaultProfile();

 ///// Profiles /////
 InFormEnterCommon.SetPrefInt("Options", 1); // lame options update

 // profiles list
 var profilesArr = InFormEnterCommon.GetPrefChar("Profiles", "").split("\n");
 var profiles_new = new Array();
 for (var i=0; i<profilesArr.length; i++)
 {
  var tmp = profilesArr[i].split("\t");
  var profileName = unescape(tmp[0]);
  var profileId = tmp[1];
  var menuSet = unescape(InFormEnterCommon.GetPrefChar(profileId+".MenuSet", ""));
  var showSize = InFormEnterCommon.GetPrefInt(profileId+".ShowSize", 0);
  var profile = new Array(profileName, profileId, menuSet, showSize);
  profiles_new.push(profile);
 }
 this.m_profiles = profiles_new;

 var profileId = InFormEnterCommon.GetPrefInt("ProfileCurrent", 1);
 this.profileListUpdateAndSelect(profileId);

 ///// Other options /////
 var et_enable = document.getElementById("ife_options_enable");
 et_enable.checked = InFormEnterCommon.GetPrefInt("On", 1);

 InFormEnterCommon.g_MarkersMode = InFormEnterCommon.GetPrefInt("MarkersMode", 1);
 var et_MEnable = document.getElementById("ife_marker_enable");
 et_MEnable.checked = InFormEnterCommon.g_MarkersMode > 0;

 if (InFormEnterCommon.g_MarkersMode < 0)
  InFormEnterCommon.g_MarkersMode *= -1;
 
 var et_MMode = document.getElementById("ife_marker_mode");
 et_MMode.value = InFormEnterCommon.g_MarkersMode;

 this.OnEnableMarkers();

 var et_Colorize = document.getElementById("ife_colorize_enable");
 var colorize = InFormEnterCommon.GetPrefInt("ColorizeItems2", 0);
 if(!InFormEnterCommon.g_FormHistory) // no interface
  colorize = 0;
 et_Colorize.checked = colorize;
 et_Colorize.setAttribute ("disabled", !InFormEnterCommon.g_FormHistory);

 var et_placement = document.getElementById("ife_options_placement");
 et_placement.selectedIndex = InFormEnterCommon.GetPrefInt("OptionsPlacement", 0);

 var et_MRClick = document.getElementById("ife_options_marker_right_click");
 et_MRClick.selectedIndex = InFormEnterCommon.GetPrefInt("MarkerRightClick", 0);

 ///// Finalize /////
 this.m_OptionsLoaded = 1;
 //var et_text = document.getElementById("ife_options_text");
 //et_text.focus();

 return true;
},

//------------------------------------------------------------------------------
OnOptionsUnload: function() 
{
 if (this.m_OptionsLoaded)
 {
  window.focus();
  if (window.confirm (InFormEnterCommon.GetPropStr("ife.msg.save")))
    this.OnOptionsAccept(false);
 }
 else
  InFormEnterCommon.SetPrefInt("Options", 0); // lame options update

 return true;
},

//------------------------------------------------------------------------------
OnProfileSelect: function()
{
 var index;
 var et_text = document.getElementById("ife_options_text");
 var et_showsize = document.getElementById("ife_options_showsize");

 // save old
 if (this.m_currentId != 0)
 {
  index = this.indexOfProfileId(this.m_currentId);
  this.m_profiles[index][2] = et_text.value;
  this.m_profiles[index][3] = et_showsize.checked;
 }

 // show new 
 var et_list = document.getElementById("ife_profile_menu");
 var menu_items = et_list.firstChild.childNodes;
 var id = menu_items[et_list.selectedIndex].getAttribute("id");
 this.m_currentId = id;

 index = this.indexOfProfileId(id);
 et_text.value = this.m_profiles[index][2];
 et_showsize.checked = this.m_profiles[index][3];

 var et_text = document.getElementById("ife_options_text");
 et_text.focus();

 return true;
},

//------------------------------------------------------------------------------
OnProfileAdd: function()
{
 var profileName = InFormEnterCommon.GetPropStr("ife.default.profile.new");

 // prompt service
 var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 var profileObj = new Object();
 var checkObj = new Object();
 profileObj.value=profileName;
 if(promptService.prompt(window,InFormEnterCommon.GetPropStr("ife.prompt.ap.caption"), InFormEnterCommon.GetPropStr("ife.prompt.ap.text"), profileObj, null, checkObj) && 
    profileObj.value.length > 0) 
   profileName=profileObj.value;
 else
   return true;
 
 var profileId = this.profileNextNumCreate();
 this.m_profiles.push (new Array(profileName, profileId, "", 0));
 this.profileListUpdateAndSelect(profileId);

 return true;
},

//------------------------------------------------------------------------------
OnProfileRename: function()
{
 // current 
 var et_list = document.getElementById("ife_profile_menu");
 var menu_items = et_list.firstChild.childNodes;
 var profileName = menu_items[et_list.selectedIndex].getAttribute("label");

 // prompt service
 var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 var profileObj = new Object();
 var checkObj = new Object();
 profileObj.value=profileName;
 if(promptService.prompt(window,InFormEnterCommon.GetPropStr("ife.prompt.rp.caption"), InFormEnterCommon.GetPropStr("ife.prompt.rp.text"), profileObj, null, checkObj) && 
    profileObj.value.length > 0) 
   profileName=profileObj.value;
 else
   return true;

 var index = this.indexOfProfileId(this.m_currentId);
 this.m_profiles[index][0] = profileName;
 this.profilesListFill(et_list); 
 this.profileListSelect(et_list, this.m_currentId);

 var et_text = document.getElementById("ife_options_text");
 et_text.focus();

 return true;
},

//------------------------------------------------------------------------------
OnProfileDel: function()
{
 var et_list = document.getElementById("ife_profile_menu");
 var menu_items = et_list.firstChild.childNodes;
 var id = menu_items[et_list.selectedIndex].getAttribute("id");

 var profileIdToSelect = 0;
 var profileDeleted = false;
 for (var i=0; i<this.m_profiles.length; i++)
 {
  var profileId = this.m_profiles[i][1];
  if (profileId == id)
  {
   this.m_profiles[i][1] = -id;
   profileDeleted = true;
  }
  else
  {
   if (profileId > 0 && profileIdToSelect == 0)
    profileIdToSelect = profileId;
  }

  if (profileIdToSelect > 0 && profileDeleted)
   break;
 }
 this.m_currentId = 0; // don`t save

 this.profileListUpdateAndSelect(profileIdToSelect); 

 return true;
},

//------------------------------------------------------------------------------
OnProfileExport: function()
{
 if (!window.confirm (InFormEnterCommon.GetPropStr("ife.prompt.profile.export.text")))
  return;

 const nsIFilePicker = Components.interfaces.nsIFilePicker;
 var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
 picker.appendFilters(nsIFilePicker.filterText | nsIFilePicker.filterAll); 
 picker.defaultExtension = "txt";
 picker.defaultString = "InFormEnter.txt";
 var title = InFormEnterCommon.GetPropStr("ife.prompt.profile.export.caption");
 picker.init (window, title, nsIFilePicker.modeSave);
 var rv = picker.show();

 if (rv != nsIFilePicker.returnCancel) 
 {
   var fos = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
   fos.init(picker.file, 0x2A, 00644, 0);

   var charset = "UTF-8";
   var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
   os.init(fos, charset, 0, 0x0000);

   for (var i=0; i<this.m_profiles.length; i++)
   {
    if(i)
     os.writeString("\n");
    os.writeString(this.m_profiles[i][0]); // Profile name
    os.writeString("\n");
    var menuSet = this.m_profiles[i][2];
    menuSet = menuSet.replace(/\n\n/g, "\n");
    menuSet = menuSet.replace(/\r\n\r\n/g, "\n");
    os.writeString(menuSet); // Profile menuset
    os.writeString("\n");
   }
   os.close();
 }
},

//------------------------------------------------------------------------------
OnProfileImport: function()
{
 if (!window.confirm (InFormEnterCommon.GetPropStr("ife.prompt.profile.import.text")))
  return;

 const nsIFilePicker = Components.interfaces.nsIFilePicker;
 var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
 picker.appendFilters(nsIFilePicker.filterText | nsIFilePicker.filterAll); 
 var title = InFormEnterCommon.GetPropStr("ife.prompt.profile.import.caption");
 picker.init (window, title, nsIFilePicker.modeOpen);
 var rv = picker.show();

 if (rv != nsIFilePicker.returnCancel) 
 {
   var fis = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
   fis.init(picker.file, 0x01, 0, 0);

   var charset = "UTF-8";
   const replacementChar = Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER;
   var is = Components.classes["@mozilla.org/intl/converter-input-stream;1"].createInstance(Components.interfaces.nsIConverterInputStream);
   is.init(fis, charset, 1024, replacementChar);
   var str = {};
   var file_as_str = "";
   while (is.readString(4096, str) != 0)
     file_as_str += str.value;
   is.close();
 }

 // parsing file_as_str
 var strArr = file_as_str.split("\n");
 var profileIdLast = 0;
 var profileName = "";
 var profileId = 0;
 var menuSet = "";
 var menuSetCount = 0;
 for (var i=0; i<strArr.length; i++)
 {
  if(strArr[i].length > 0)
  {
   if(profileId > 0)
   {
    if(menuSetCount > 0)
     menuSet += "\n";
    menuSet += strArr[i];
    menuSetCount++;
   }
   else
   {
    profileName = strArr[i];
    profileId = this.profileNextNumCreate();
   }
  }
  else
  {
   if(profileId > 0)
   {
    this.m_profiles.push (new Array(profileName, profileId, menuSet, 0));
    profileIdLast = profileId;
    profileName = "";
    profileId = 0;
    menuSet = "";
    menuSetCount = 0;
   }
  }
 }

 if(profileId > 0)
 {
  this.m_profiles.push (new Array(profileName, profileId, menuSet, 0));
  profileIdLast = profileId;
 }

 this.profileListUpdateAndSelect(profileIdLast);
},

//------------------------------------------------------------------------------
OnEnableMarkers: function()
{
 var et_MEnable = document.getElementById("ife_marker_enable");
 //et_MEnable.checked
 var et_MMode = document.getElementById("ife_marker_mode");
 et_MMode.disabled = !et_MEnable.checked;
},

//------------------------------------------------------------------------------
OnWarningColorize: function()
{
 var et_Colorize = document.getElementById("ife_colorize_enable");
 if (et_Colorize.checked)
  alert (InFormEnterCommon.GetPropStr("ife.msg.warning.colorize"));
},

//------------------------------------------------------------------------------
OnOptionsAccept: function(toCloseWindow) 
{
 ///// Profiles /////
 // current profile data
 var index = this.indexOfProfileId(this.m_currentId);
 var et_text = document.getElementById("ife_options_text");
 var et_showsize = document.getElementById("ife_options_showsize");

 this.m_profiles[index][2] = et_text.value;
 this.m_profiles[index][3] = et_showsize.checked;

 // all profiles
 var profilesStr = "";
 for (var i=0; i<this.m_profiles.length; i++)
 {
  var profileId = this.m_profiles[i][1];
  if (profileId > 0) 
  {
   // to save profile
   var profileName = this.m_profiles[i][0];
   var menuSet = this.m_profiles[i][2];
   var showSize = this.m_profiles[i][3];
   
   //
   if (profilesStr != "")
    profilesStr += "\n";
   profilesStr += (escape(profileName) + "\t" + profileId);

   //  
   InFormEnterCommon.SetPrefChar(profileId+".MenuSet", escape(menuSet));
   InFormEnterCommon.SetPrefInt(profileId+".ShowSize", showSize);
  }
  else
  {
   // to delete profile
   InFormEnterCommon.g_Preferences.deleteBranch (profileId+".MenuSet");
   InFormEnterCommon.g_Preferences.deleteBranch (profileId+".ShowSize");
  }
 }
 InFormEnterCommon.SetPrefChar("Profiles", profilesStr);

 // current Id
 if (this.m_currentId != 0)
  InFormEnterCommon.SetPrefInt("ProfileCurrent", this.m_currentId);

 ///// Other options /////
 var et_enable = document.getElementById("ife_options_enable");
 InFormEnterCommon.SetPrefInt("On", et_enable.checked);

 var et_MEnable = document.getElementById("ife_marker_enable");
 var et_MMode = document.getElementById("ife_marker_mode");
 InFormEnterCommon.g_MarkersMode = et_MMode.value;
 if (!et_MEnable.checked)
  InFormEnterCommon.g_MarkersMode *= -1;

 InFormEnterCommon.SetPrefInt("MarkersMode", InFormEnterCommon.g_MarkersMode);

 var et_Colorize = document.getElementById("ife_colorize_enable");
 InFormEnterCommon.SetPrefInt("ColorizeItems2", et_Colorize.checked);

 var et_placement = document.getElementById("ife_options_placement");
 InFormEnterCommon.SetPrefInt("OptionsPlacement", et_placement.selectedIndex);

 var et_MRClick = document.getElementById("ife_options_marker_right_click");
 InFormEnterCommon.SetPrefInt("MarkerRightClick", et_MRClick.selectedIndex);

 ///// Finalize /////
 this.m_OptionsLoaded = 0;
 
 if (toCloseWindow)
  window.close();

 return true;
},

//------------------------------------------------------------------------------
OnOptionsCancel: function() 
{
 this.m_OptionsLoaded = 0;
 window.close();
 return true;
}

};